package com.madeu.controller.web.webkakaotemplate;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webkakaotemplate.WebKakaoTemplateService;
import com.madeu.util.HttpUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;

@Slf4j
@Controller
public class WebKakaoTemplateController extends ManagerDraftAction {

    @Autowired
    private WebKakaoTemplateService webKakaoTemplateService;

    /**
     * 알림톡 템플릿 리스트 조회 (option)
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webkakaotemplate/selectListKakaoTemplateOption.do")
    public ModelAndView selectListKakaoTemplateOption(HttpSession session,HttpServletRequest request, HttpServletResponse response) {

        log.debug("WebKakaoTemplateController selectListKakaoTemplateOption START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webKakaoTemplateService.selectListKakaoTemplateOption(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebKakaoTemplateController selectListKakaoTemplateOption END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 알림톡 템플릿 상세 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webkakaotemplate/selectKakaoTemplate.do")
    public ModelAndView selectKakaoTemplate(HttpSession session,HttpServletRequest request, HttpServletResponse response) {

        log.debug("WebKakaoTemplateController selectKakaoTemplate START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webKakaoTemplateService.selectKakaoTemplate(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebKakaoTemplateController selectKakaoTemplate END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
}
